from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.MetaBrain.config import PROJECTNAME, GLOBALS


def addToFactoryTool(self, out):
    print >> out, 'portal_factory modifications started.'

    ftool = getToolByName(self, 'portal_factory')

    if ftool:
        portal_factory_types = ftool.getFactoryTypes().keys()

    for portalType in [ typeDict['portal_type'] for typeDict in listTypes(PROJECTNAME) ]:
        if portalType not in portal_factory_types:
            portal_factory_types.append(portalType)
            ftool.manage_setPortalFactoryTypes(listOfTypeIds=portal_factory_types)
            print >> out, '    %s now uses portal_factory' % portalType

    print >> out, 'portal_factory modifications done.'


def install(self):
    """Install content types, enable the portal factory"""

    out = StringIO()

    print >> out, "Installing %s" % PROJECTNAME

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"

    # install subskin (in the skins dir?)
    install_subskin(self, out, GLOBALS)
    print >> out, "installed subskin"

    addToFactoryTool(self, out)



    # do the generic setup stuff
    tool=getToolByName(self, "portal_setup")
    profile = "profile-Products.%s:default" % PROJECTNAME

    try:
        tool.runAllImportStepsFromProfile(profile, purge_old=False)
    except AttributeError:   # before plone 3
        tool.setImportContext(profile)
        tool.runAllImportSteps(purge_old=False)
    print >> out, 'Imported generic setup import of profile.'



    # return log-string
    return out.getvalue()
