from Products.Archetypes.atapi import process_types, listTypes
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.permissions import AddPortalContent

# Product imports
from config import PROJECTNAME, GLOBALS, SKINS_DIR

# Import the content types modules
import metabrain

registerDirectory(SKINS_DIR, GLOBALS)

def initialize(context):
    content_types, constructors, ftis = process_types(
             listTypes(PROJECTNAME),
             PROJECTNAME)

    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECTNAME, atype.portal_type)
        utils.ContentInit(kind,
                          content_types      = (atype,),
                          extra_constructors = (constructor,),
                          fti                = ftis,
                          permission         = AddPortalContent,
                          ).initialize(context)
