from Products.Archetypes.public import BaseFolderSchema, Schema
from Products.Archetypes.public import StringField
from Products.Archetypes.public import BaseFolder, registerType
from Products.Archetypes.atapi import *
from Products.MetaBrain.config import PROJECTNAME
from Products.CMFCore.utils import getToolByName
from AccessControl import ClassSecurityInfo

class GeekProfile(BaseContent):
    """simple type for testig metadata and caching and brains."""
    schema = BaseSchema.copy() + Schema((

        IntegerField(
            name = 'FavNumber',
            required = 1,
            ),

        IntegerField(
            name = 'TheBigSolutionNumber',
            required = 1,
            ),

        LinesField(
            name='OperatingSystem',
            vocabulary=['GNU', 'GNU/Linux', 'Other Unix-like', 'Other'],
            widget=MultiSelectionWidget(format='checkbox', ),
            ),


        LinesField(
            name='Editor',
            vocabulary=['Emacs', 'Nano', 'Vi', 'Visual Studio', 'Other'],
            widget=MultiSelectionWidget(format='checkbox', ),
            ),

        ))

    security = ClassSecurityInfo()

    _at_rename_after_creation = True
    global_allow = 0

    security.declarePublic('SumOfNumbers')
    def SumOfNumbers(self):
        "get the sum of all integers in the type or 0."
        try:
            return self.FavNumber + self.TheBigSolutionNumber
        except:
            return 0



registerType(GeekProfile, PROJECTNAME)


class GeekFolder(BaseFolder):
    "A folder to put geeks in."
    allowed_content_types = ('GeekProfile', )
    filter_content_types = 1
    _at_rename_after_creation = True

    security = ClassSecurityInfo()


    security.declarePublic('Latest')
    def Latest(self, n=5):
        "Get five latest geeks"
        catalog = getToolByName(self, 'portal_catalog')

        path = '/'.join(self.getPhysicalPath()),

        results = catalog.searchResults(
            sort_on='created',
            sort_order='reverse',
            path = {'query' : path, 'level' : 0, 'depth' : 1}
            )

        return results[:n]


registerType(GeekFolder, PROJECTNAME)
